//Creating the bullets may seem challenging if your not used to DM, but it's fairly easy.

//You start out by defining a typical game object.

obj
	bullet			//create an object called bullet.




		icon='bullet.dmi'		//this tells the engine what graphics file to use.
		icon_state=""			//this specifies which graphic to use. in this case, we're leaving it blank - since I didn't name the graphic.

		density=1			//it's a dense object ( it can collide)

		step_size=4				//moves 8 pixels at a time using default movement behavior


//now comes the fun part, you need to tell the bullet to "drop" down every tick, which can be accomplished using a loop.

//so let's create a procedure called "fall" and tell the bullet to move down every 0.1 seconds.

		proc
			fall()
				loop_label


					step(src,SOUTH)			//tells this object to move south



					if(src.y==1)del src			//delete the bullet if we reach the ground

					sleep(0.5)			//waits 0.05 second to move again
					goto loop_label			//this cycles back to the "loop" label. ( you could call this anything)

//of course, we need to call this block of code at some point, so we can do that using the New() function

		New()
			..()			//do default behavior first.
			spawn(0)fall()			//using the spawn() function allows fall() to trigger separate from the New() function. It essentially lets New() finish executing while still calling our AI loop.


//now the bullet will fall down without a problem.

//however, we need to know when we hit the player, we can do this using the Bump() function

//the bump function is called when a movement fails due to a dense blockage from another game object.

		Bump(var/atom/thing_we_bumped_into)
			..()			//default behavior...
			if(istype(thing_we_bumped_into,/mob))			//if we bumped into a mob....
				reset_score()									//reset the score!			(Look at score keeping)
			del src									//if we hit anything, delete the bullet!